const
  cpackset: array[1..4] of byte = (1,2,4,8);
  maxlow=32;
  maxhigh=64;

function nset(setnr,psi: longint): longint;
begin
  nset:=setnr+psi*(succ(maxlow)*succ(maxhigh));
end;

var
  t: text;
  psi, lowset, highset, setnr: longint;
begin
  assign(t,'createsetdata.pp');
  rewrite(t);

  writeln(t,'var f: file;');
  psi:=0;
  setnr:=0;
  while (psi<=high(cpackset)) do
    begin
      for lowset:=0 to maxlow do
        for highset:=lowset to maxhigh do
          begin
            writeln(t,'type');
            writeln(t,'  ts',nset(setnr,psi),'= set of ',lowset,'..',highset,';');
            writeln(t,'var');
            writeln(t,'  s',nset(setnr,psi),': ts',nset(setnr,psi),';');
            inc(setnr);
          end;
      writeln(t);
      inc(psi);
//      if (psi<=high(cpackset)) then
//        writeln(t,'{$packset ',cpackset[psi],'}');
    end;
    writeln(t);

    setnr:=0;
    psi:=0;
    while (psi<=high(cpackset)) do
      begin
        writeln(t,'procedure testps',psi,';');
        writeln(t,'var');
        writeln(t,'  i: longint;');
        writeln(t,'begin');
        for lowset:=0 to maxlow do
          for highset:=lowset to maxhigh do
            begin
              writeln(t,'  for i:=',lowset,' to ',highset,' do');
              writeln(t,'    include(s',nset(setnr,psi),',',lowset,'+random(',highset-lowset+1,'));');
              writeln(t,'  blockwrite(f,s',nset(setnr,psi),',sizeof(s',nset(setnr,psi),'));');
              inc(setnr);
            end;
        inc(psi);
        writeln(t,'end;');
      end;
    writeln(t,'begin');
    writeln(t,'  randseed:=1;');
    writeln(t,'  assign(f,''setdata.dat'');');
    writeln(t,'  rewrite(f,1);');
    for psi:=0 to high(cpackset) do
      writeln(t,'  testps',psi,';');
    writeln(t,'  close(f);');
    writeln(t,'end.');
    close(t);
end.
